#include <sys/types.h> /* predefined types */
#include <unistd.h> /* include unix standard library */
#include <arpa/inet.h> /* IP addresses conversion utililites */
#include <sys/socket.h> /* socket library */
#include <stdio.h> /* include standard I/O library */
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <signal.h>
int count;
int list_fd,conn_fd;


void handler(int sig){
	if(sig==SIGCHLD) {
		count++;
		printf("Figlio terminato\n");
	}
}


int main (int argc , char *argv[]){

	int i;
	struct sockaddr_in serv_add,client;
	char buffer [1024];
	socklen_t len;
	time_t timeval;
	pid_t pid;
	int logging =1;
	int enable = 1;

	count=0;

	//SIGCHLD è inviato da ogni processo figlio (quando essi sono terminati) al processo padre
	signal(SIGCHLD, handler);å

	if( (list_fd=socket(AF_INET, SOCK_STREAM, 0)) < 0 )
	{ 
		perror("socket"); exit(-1);
	} 

	serv_add.sin_family=AF_INET;
	serv_add.sin_addr.s_addr=htonl(INADDR_ANY);
	serv_add.sin_port=htons(1024);

	if(setsockopt(list_fd,SOL_SOCKET,SO_REUSEPORT,&enable,sizeof(int))<0)
	{
		printf("Errore setsockopt\n");
	}

	if(setsockopt(list_fd,SOL_SOCKET,SO_REUSEADDR,&enable,sizeof(int))<0)
	{
		printf("Errore setsockopt\n");
	}

	if ( bind(list_fd, (struct sockaddr *) &serv_add, sizeof(serv_add))  < 0 )
	{
		perror("error bind"); exit(-1);
	}

	if( listen(list_fd, 1024)< 0)
	{
		perror("error listen"); exit(-1);
	}

	while(1)
	{
		len = sizeof ( client );
		conn_fd=accept(list_fd, (struct sockaddr*)&client, &len);

		//Errore nella fork (Pid<0)
		if((pid= fork())<0)	
			{
			perror (" fork error ");
			exit ( -1);
			}
		if(pid==0)
			{ //SE SONO IL FIGLIO GESTISCO IL SERVZIO (Pid=0)
			close ( list_fd ); //Chiudo il socket descriptor in attesa di nuove connessioni
			timeval = time ( NULL );
			snprintf(buffer,sizeof(buffer)," %.24s\r\n",ctime(& timeval));
			if( write(conn_fd, buffer, strlen(buffer)) < 0){
				printf("errore\n"); exit(-1);
				}

			if(logging)
				{
				inet_ntop(AF_INET,&client.sin_addr,buffer,sizeof(buffer));
				printf("Request from host number %d - %s, port %d\n",count,buffer,ntohs(client.sin_port));
				}
			close(conn_fd);
			exit (-1);
			}
		else 
			{ //SE SONO IL PADRE (Pid>0)
			close ( conn_fd ); //Chiudo il socket descriptor per comunicare con il client
			}
	}
	// normal exit , never reached

	close(list_fd);
	exit (0);
}
